Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -72,7 +72,8 @@
 {
 	int rc;
-
-	rc = udebug_begin(call);
-	if (rc < 0) {
+	bool active;
+
+	rc = udebug_begin(call, &active);
+	if (rc != EOK) {
 		IPC_SET_RETVAL(call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
@@ -84,6 +85,6 @@
 	 * send a reply.
 	 */
-	if (rc != 0) {
-		IPC_SET_RETVAL(call->data, 0);
+	if (active) {
+		IPC_SET_RETVAL(call->data, EOK);
 		ipc_answer(&TASK->kb.box, call);
 	}
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -46,4 +46,5 @@
 #include <errno.h>
 #include <print.h>
+#include <stdbool.h>
 #include <str.h>
 #include <syscall/copy.h>
@@ -157,18 +158,21 @@
  *
  * Initiates a debugging session for the current task (and its threads).
- * When the debugging session has started a reply will be sent to the
+ * When the debugging session has started a reply should be sent to the
  * UDEBUG_BEGIN call. This may happen immediately in this function if
  * all the threads in this task are stoppable at the moment and in this
- * case the function returns 1.
- *
- * Otherwise the function returns 0 and the reply will be sent as soon as
- * all the threads become stoppable (i.e. they can be considered stopped).
+ * case the function sets @a *active to @c true.
+ *
+ * Otherwise the function sets @a *active to false and the resonse should
+ * be sent as soon as all the threads become stoppable (i.e. they can be
+ * considered stopped).
  *
  * @param call The BEGIN call we are servicing.
- *
- * @return 0 (OK, but not done yet), 1 (done) or negative error code.
- *
- */
-int udebug_begin(call_t *call)
+ * @param active Place to store @c true iff we went directly to active state,
+ *               @c false if we only went to beginning state
+ *
+ * @return EOK on success, EBUSY if the task is already has an active
+ *         debugging session.
+ */
+int udebug_begin(call_t *call, bool *active)
 {
 	LOG("Debugging task %" PRIu64, TASK->taskid);
@@ -185,12 +189,10 @@
 	TASK->udebug.debugger = call->sender;
 	
-	int reply;
-	
 	if (TASK->udebug.not_stoppable_count == 0) {
 		TASK->udebug.dt_state = UDEBUG_TS_ACTIVE;
 		TASK->udebug.begin_call = NULL;
-		reply = 1;  /* immediate reply */
+		*active = true;  /* directly to active state */
 	} else
-		reply = 0;  /* no reply */
+		*active = false;  /* only in beginning state */
 	
 	/* Set udebug.active on all of the task's userspace threads. */
@@ -207,5 +209,5 @@
 	
 	mutex_unlock(&TASK->udebug.lock);
-	return reply;
+	return EOK;
 }
 
Index: release/Makefile
===================================================================
--- release/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ release/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,4 +43,5 @@
 	ia64/ski \
 	mips32/malta-be \
+	mips32/malta-le \
 	mips32/msim \
 	ppc32 \
@@ -48,5 +49,5 @@
 	sparc64/ultra
 
-BZR = bzr
+GIT = git
 TAR = tar
 
@@ -91,5 +92,5 @@
 	rm -rf $(EXPORT_DIR)
 	mkdir -p $(EXPORT_DIR)
-	$(BZR) export $(EXPORT_DIR) ../
+	(cd ..; $(GIT) archive master) | $(TAR) -x -C $(EXPORT_DIR)
 
 src_rel $(SRC_ARCHIVE): export
Index: tools/grub/grub-update.sh
===================================================================
--- tools/grub/grub-update.sh	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ tools/grub/grub-update.sh	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -59,5 +59,5 @@
 	rm -f "$helenosdir"/boot/"$gdir"/"$platform"/*.image || exit 1
 	rm -f "$helenosdir"/boot/"$gdir"/"$platform"/*.module || exit 1
-	bzr add "$helenosdir"/boot/"$gdir"/"$platform" || exit 1
+	git add "$helenosdir"/boot/"$gdir"/"$platform" || exit 1
 }
 
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -136,4 +136,5 @@
 	srv/hw/char/s3c24xx_uart \
 	srv/hid/rfb \
+	srv/test/chardev-test \
 	drv/audio/hdaudio \
 	drv/audio/sb16 \
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/barber/barber.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <task.h>
 #include <loc.h>
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -180,10 +180,12 @@
     off64_t head, off64_t tail, bool tail_first)
 {
-	int fd, bytes = 0, count = 0, reads = 0;
+	int fd, count = 0, reads = 0;
+	size_t bytes;
 	char *buff = NULL;
-	int i;
+	size_t i;
 	size_t offset = 0, copied_bytes = 0;
 	off64_t file_size = 0, length = 0;
 	aoff64_t pos = 0;
+	int rc;
 
 	bool reading_stdin = dash_represents_stdin && (str_cmp(fname, "-") == 0);
@@ -193,6 +195,10 @@
 		/* Allow storing the whole UTF-8 character. */
 		blen = STR_BOUNDS(1);
-	} else
-		fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
+	} else {
+		int rc = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ, &fd);
+		if (rc != EOK) {
+			fd = -1;
+		}
+	}
 	
 	if (fd < 0) {
@@ -250,8 +256,9 @@
 		}
 		
-		bytes = vfs_read(fd, &pos, buff + copied_bytes, bytes_to_read);
+		rc = vfs_read(fd, &pos, buff + copied_bytes, bytes_to_read,
+		    &bytes);
 		copied_bytes = 0;
 
-		if (bytes > 0) {
+		if (rc == EOK && bytes > 0) {
 			buff[bytes] = '\0';
 			offset = 0;
@@ -284,8 +291,8 @@
 		if (reading_stdin)
 			fflush(stdout);
-	} while (bytes > 0 && !should_quit && (count < length || length == CAT_FULL_FILE));
+	} while (rc == EOK && bytes > 0 && !should_quit && (count < length || length == CAT_FULL_FILE));
 
 	vfs_put(fd);
-	if (bytes == -1) {
+	if (rc != EOK) {
 		printf("Error reading %s\n", fname);
 		free(buff);
Index: uspace/app/bdsh/cmds/modules/cmp/cmp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cmp/cmp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/cmp/cmp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -72,15 +72,14 @@
 static int cmp_files(const char *fn0, const char *fn1)
 {
-	int rc = 0;
+	int rc = EOK;
 	const char *fn[2] = {fn0, fn1};
 	int fd[2] = {-1, -1};
 	char buffer[2][CMP_BUFLEN];
-	ssize_t offset[2];
+	size_t offset[2];
 	aoff64_t pos[2] = {};
 
 	for (int i = 0; i < 2; i++) {
-		fd[i] = vfs_lookup_open(fn[i], WALK_REGULAR, MODE_READ);
-		if (fd[i] < 0) {
-			rc = fd[i];
+		rc = vfs_lookup_open(fn[i], WALK_REGULAR, MODE_READ, &(fd[i]));
+		if (rc != EOK) {
 			printf("Unable to open %s\n", fn[i]);
 			goto end;
@@ -90,22 +89,16 @@
 	do {
 		for (int i = 0; i < 2; i++) {
-			offset[i] = 0;
-			ssize_t size;
-			do {
-				size = vfs_read(fd[i], &pos[i],
-				    buffer[i] + offset[i],
-				    CMP_BUFLEN - offset[i]);
-				if (size < 0) {
-					rc = size;
-					printf("Error reading from %s\n",
-					    fn[i]);
-					goto end;
-				}
-				offset[i] += size;
-			} while (size && offset[i] < CMP_BUFLEN);
+			rc = vfs_read(fd[i], &pos[i], buffer[i], CMP_BUFLEN,
+			    &offset[i]);
+			if (rc != EOK) {
+				printf("Error reading from %s\n",
+				    fn[i]);
+				goto end;
+			}
 		}
 
 		if (offset[0] != offset[1] ||
 		    memcmp(buffer[0], buffer[1], offset[0]) != 0) {
+			printf("Return 1\n");
 			rc = 1;
 			goto end;
@@ -149,5 +142,5 @@
 
 	rc = cmp_files(argv[optind], argv[optind + 1]);
-	if (rc)
+	if (rc != EOK)
 		return CMD_FAILURE;
 	else
Index: uspace/app/bdsh/cmds/modules/cp/cp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -28,4 +28,5 @@
 
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -66,5 +67,5 @@
 } dentry_type_t;
 
-static int64_t copy_file(const char *src, const char *dest,
+static int copy_file(const char *src, const char *dest,
     size_t blen, int vb);
 
@@ -175,8 +176,8 @@
 }
 
-static int64_t do_copy(const char *src, const char *dest,
+static int do_copy(const char *src, const char *dest,
     size_t blen, int vb, int recursive, int force, int interactive)
 {
-	int r = -1;
+	int rc = EOK;
 	char dest_path[PATH_MAX];
 	char src_path[PATH_MAX];
@@ -217,4 +218,5 @@
 				printf("The dest directory %s does not exists",
 				    dest_path);
+				rc = ENOENT;
 				goto exit;
 			}
@@ -224,4 +226,5 @@
 			printf("Cannot overwrite existing directory %s\n",
 			    dest_path);
+			rc = EEXIST;
 			goto exit;
 		} else if (dest_type == TYPE_FILE) {
@@ -233,5 +236,6 @@
 			 */
 			if (force && !interactive) {
-				if (vfs_unlink_path(dest_path) != EOK) {
+				rc = vfs_unlink_path(dest_path);
+				if (rc != EOK) {
 					printf("Unable to remove %s\n",
 					    dest_path);
@@ -244,5 +248,6 @@
 				if (overwrite) {
 					printf("Overwriting file: %s\n", dest_path);
-					if (vfs_unlink_path(dest_path) != EOK) {
+					rc = vfs_unlink_path(dest_path);
+					if (rc != EOK) {
 						printf("Unable to remove %s\n", dest_path);
 						goto exit;
@@ -250,9 +255,10 @@
 				} else {
 					printf("Not overwriting file: %s\n", dest_path);
-					r = 0;
+					rc = EOK;
 					goto exit;
 				}
 			} else {
 				printf("File already exists: %s\n", dest_path);
+				rc = EEXIST;
 				goto exit;
 			}
@@ -260,5 +266,5 @@
 
 		/* call copy_file and exit */
-		r = (copy_file(src, dest_path, blen, vb) < 0);
+		rc = (copy_file(src, dest_path, blen, vb) < 0);
 
 	} else if (src_type == TYPE_DIR) {
@@ -268,7 +274,9 @@
 			printf("Cannot copy the %s directory without the "
 			    "-r option\n", src);
+			rc = EINVAL;
 			goto exit;
 		} else if (dest_type == TYPE_FILE) {
 			printf("Cannot overwrite a file with a directory\n");
+			rc = EEXIST;
 			goto exit;
 		}
@@ -293,6 +301,7 @@
 				merge_paths(dest_path, PATH_MAX, src_dirname);
 
-				if (vfs_link_path(dest_path, KIND_DIRECTORY,
-				    NULL) != EOK) {
+				rc = vfs_link_path(dest_path, KIND_DIRECTORY,
+				    NULL);
+				if (rc != EOK) {
 					printf("Unable to create "
 					    "dest directory %s\n", dest_path);
@@ -308,6 +317,6 @@
 			 * e.g. cp -r /src /data/new_dir_src
 			 */
-			if (vfs_link_path(dest_path, KIND_DIRECTORY,
-			    NULL) != EOK) {
+			rc = vfs_link_path(dest_path, KIND_DIRECTORY, NULL);
+			if (rc != EOK) {
 				printf("Unable to create "
 				    "dest directory %s\n", dest_path);
@@ -321,4 +330,5 @@
 			/* Something strange is happening... */
 			printf("Unable to open src %s directory\n", src);
+			rc = ENOENT;
 			goto exit;
 		}
@@ -348,4 +358,5 @@
 				printf("Cannot copy a directory "
 				    "into itself\n");
+				rc = EEXIST;
 				goto exit;
 			}
@@ -355,7 +366,7 @@
 
 			/* Recursively call do_copy() */
-			r = do_copy(src_dent, dest_dent, blen, vb, recursive,
+			rc = do_copy(src_dent, dest_dent, blen, vb, recursive,
 			    force, interactive);
-			if (r)
+			if (rc != EOK)
 				goto exit;
 
@@ -367,13 +378,14 @@
 	if (dir)
 		closedir(dir);
-	return r;
-}
-
-static int64_t copy_file(const char *src, const char *dest,
+	return rc;
+}
+
+static int copy_file(const char *src, const char *dest,
 	size_t blen, int vb)
 {
-	int fd1, fd2, bytes;
+	int fd1, fd2;
+	size_t rbytes, wbytes;
+	int rc;
 	off64_t total;
-	int64_t copied = 0;
 	char *buff = NULL;
 	aoff64_t posr = 0, posw = 0;
@@ -383,12 +395,12 @@
 		printf("Copying %s to %s\n", src, dest);
 
-	fd1 = vfs_lookup_open(src, WALK_REGULAR, MODE_READ);
-	if (fd1 < 0) {
+	rc = vfs_lookup_open(src, WALK_REGULAR, MODE_READ, &fd1);
+	if (rc != EOK) {
 		printf("Unable to open source file %s\n", src);
 		return -1;
 	}
 
-	fd2 = vfs_lookup_open(dest, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE);
-	if (fd2 < 0) {
+	rc = vfs_lookup_open(dest, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE, &fd2);
+	if (rc != EOK) {
 		printf("Unable to open destination file %s\n", dest);
 		vfs_put(fd1);
@@ -410,17 +422,17 @@
 		printf("Unable to allocate enough memory to read %s\n",
 		    src);
-		copied = -1;
+		rc = ENOMEM;
 		goto out;
 	}
 
-	while ((bytes = vfs_read(fd1, &posr, buff, blen)) > 0) {
-		if ((bytes = vfs_write(fd2, &posw, buff, bytes)) < 0)
-			break;
-		copied += bytes;
-	}
-
-	if (bytes < 0) {
-		printf("\nError copying %s, (%d)\n", src, bytes);
-		copied = bytes;
+	while ((rc = vfs_read(fd1, &posr, buff, blen, &rbytes)) == EOK &&
+	    rbytes > 0) {
+		if ((rc = vfs_write(fd2, &posw, buff, rbytes, &wbytes)) != EOK)
+			break;
+	}
+
+	if (rc != EOK) {
+		printf("\nError copying %s: %s\n", src, str_error(rc));
+		return rc;
 	}
 
@@ -430,5 +442,5 @@
 	if (buff)
 		free(buff);
-	return copied;
+	return rc;
 }
 
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -32,4 +32,5 @@
 
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -184,5 +185,5 @@
 		if (rc != EOK) {
 			printf("ls: skipping bogus node %s\n", buff);
-			printf("error=%d\n", rc);
+			printf("error=%s\n", str_error_name(rc));
 			goto out;
 		}
Index: uspace/app/bdsh/cmds/modules/mkfile/mkfile.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -31,4 +31,5 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <str_error.h>
 #include <dirent.h>
 #include <macros.h>
@@ -85,17 +86,20 @@
  *
  * @param str	String containing the size specification.
- * @return	Non-negative size in bytes on success, -1 on failure.
+ * @param rsize	Place to store size in bytes
+ * @return	EOK on success or error code
  */
-static ssize_t read_size(const char *str)
+static int read_size(const char *str, size_t *rsize)
 {
-	ssize_t number, unit;
+	size_t number, unit;
 	char *ep;
 
 	number = strtol(str, &ep, 10);
-	if (ep[0] == '\0')
-		return number;
+	if (ep[0] == '\0') {
+		*rsize = number;
+		return EOK;
+	}
 
 	if (ep[1] != '\0')
-		    return -1;
+		    return EINVAL;
 
 	switch (tolower(ep[0])) {
@@ -103,8 +107,9 @@
 	case 'm': unit = 1024*1024; break;
 	case 'g': unit = 1024*1024*1024; break;
-	default: return -1;
-	}
-
-	return number * unit;
+	default: return EINVAL;
+	}
+
+	*rsize = number * unit;
+	return EOK;
 }
 
@@ -114,7 +119,9 @@
 	int c, opt_ind;
 	int fd;
-	ssize_t file_size;
-	ssize_t total_written;
-	ssize_t to_write, rc, rc2 = 0;
+	size_t file_size;
+	size_t total_written;
+	size_t to_write;
+	size_t nwritten;
+	int rc;
 	char *file_name;
 	void *buffer;
@@ -136,6 +143,6 @@
 			break;
 		case 's':
-			file_size = read_size(optarg);
-			if (file_size < 0) {
+			rc = read_size(optarg, &file_size);
+			if (rc != EOK) {
 				printf("%s: Invalid file size specification.\n",
 				    cmdname);
@@ -156,6 +163,6 @@
 	file_name = argv[optind];
 
-	fd = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MUST_CREATE, MODE_WRITE);
-	if (fd < 0) {
+	rc = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MUST_CREATE, MODE_WRITE, &fd);
+	if (rc != EOK) {
 		printf("%s: failed to create file %s.\n", cmdname, file_name);
 		return CMD_FAILURE;
@@ -166,6 +173,6 @@
 		
 		pos = file_size - 1;
-		rc2 = vfs_write(fd, &pos, &byte, sizeof(char));
-		if (rc2 < 0) {
+		rc = vfs_write(fd, &pos, &byte, sizeof(char), &nwritten);
+		if (rc != EOK) {
 			vfs_put(fd);
 			goto error;
@@ -183,12 +190,12 @@
 	while (total_written < file_size) {
 		to_write = min(file_size - total_written, BUFFER_SIZE);
-		rc = vfs_write(fd, &pos, buffer, to_write);
-		if (rc <= 0) {
-			printf("%s: Error writing file (%d).\n", cmdname, errno);
+		rc = vfs_write(fd, &pos, buffer, to_write, &nwritten);
+		if (rc != EOK) {
+			printf("%s: Error writing file (%s).\n", cmdname, str_error(errno));
 			vfs_put(fd);
 			free(buffer);
 			return CMD_FAILURE;
 		}
-		total_written += rc;
+		total_written += nwritten;
 	}
 
@@ -200,5 +207,5 @@
 	return CMD_SUCCESS;
 error:
-	printf("%s: Error writing file (%d).\n", cmdname, errno);
+	printf("%s: Error writing file (%s).\n", cmdname, str_error(errno));
 	return CMD_FAILURE;
 }
Index: uspace/app/bdsh/cmds/modules/mv/mv.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mv/mv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/mv/mv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,4 +30,5 @@
 #include <stdlib.h>
 #include <errno.h>
+#include <str_error.h>
 #include <vfs/vfs.h>
 #include "config.h"
@@ -62,6 +63,6 @@
 	rc = vfs_rename_path(argv[1], argv[2]);
 	if (rc != EOK) {
-		printf("Unable to rename %s to %s (error=%d)\n",
-		    argv[1], argv[2], rc);
+		printf("Unable to rename %s to %s: %s)\n",
+		    argv[1], argv[2], str_error(rc));
 		return CMD_FAILURE;
 	}
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -149,6 +149,5 @@
 	}
 
-	fd = vfs_lookup(path, WALK_REGULAR);
-	if (fd >= 0) {
+	if (vfs_lookup(path, WALK_REGULAR, &fd) == EOK) {
 		vfs_put(fd);
 		return RM_FILE;
Index: uspace/app/bdsh/cmds/modules/sleep/sleep.c
===================================================================
--- uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,8 +27,8 @@
  */
 
+#include <async.h>
 #include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <thread.h>
 #include "config.h"
 #include "util.h"
@@ -131,5 +131,5 @@
 	}
 
-	(void) thread_usleep(duration);
+	async_usleep(duration);
 
 	return CMD_SUCCESS;
Index: uspace/app/bdsh/cmds/modules/touch/touch.c
===================================================================
--- uspace/app/bdsh/cmds/modules/touch/touch.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/touch/touch.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -123,5 +123,8 @@
 		if ((!no_create) ||
 		    ((no_create) && (vfs_stat_path(buff, &file_stat) == EOK))) {
-			fd = vfs_lookup(buff, WALK_REGULAR | WALK_MAY_CREATE);
+			int rc = vfs_lookup(buff, WALK_REGULAR | WALK_MAY_CREATE, &fd);
+			if (rc != EOK) {
+				fd = -1;
+			}
 		}
 		
Index: uspace/app/bdsh/cmds/modules/unmount/unmount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -31,4 +31,5 @@
 #include <vfs/vfs.h>
 #include <errno.h>
+#include <str_error.h>
 #include "config.h"
 #include "util.h"
@@ -68,5 +69,5 @@
 	rc = vfs_unmount_path(argv[1]);
 	if (rc != EOK) {
-		printf("Unable to unmount %s (rc=%d)\n", argv[1], rc);
+		printf("Unable to unmount %s: %s\n", argv[1], str_error(rc));
 		return CMD_FAILURE;
 	}
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/exec.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -58,6 +58,6 @@
 	int fd;
 
-	fd = vfs_lookup_open(f, WALK_REGULAR, MODE_READ);
-	if (fd >= 0) {
+	int rc = vfs_lookup_open(f, WALK_REGULAR, MODE_READ, &fd);
+	if (rc == EOK) {
 		vfs_put(fd);
 		return 0;
Index: uspace/app/bdsh/tok.c
===================================================================
--- uspace/app/bdsh/tok.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bdsh/tok.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,5 +29,4 @@
 #include <str.h>
 #include <assert.h>
-#include <malloc.h>
 #include <stdlib.h>
 #include <stddef.h>
Index: uspace/app/bnchmark/bnchmark.c
===================================================================
--- uspace/app/bnchmark/bnchmark.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/bnchmark/bnchmark.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <str_error.h>
 #include <mem.h>
 #include <loc.h>
@@ -186,5 +187,5 @@
 		rc = measure(fn, path, &milliseconds_taken);
 		if (rc != EOK) {
-			fprintf(stderr, "Error %d\n", rc);
+			fprintf(stderr, "Error: %s\n", str_error(rc));
 			return 1;
 		}
Index: uspace/app/date/date.c
===================================================================
--- uspace/app/date/date.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/date/date.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -33,5 +33,5 @@
 #include <loc.h>
 #include <time.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <getopt.h>
 #include <ctype.h>
Index: uspace/app/devctl/devctl.c
===================================================================
--- uspace/app/devctl/devctl.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/devctl/devctl.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -324,5 +324,5 @@
 	rc = devman_driver_get_handle(drvname, &drvh);
 	if (rc != EOK) {
-		printf("Failed resolving driver '%s' (%d).\n", drvname, rc);
+		printf("Failed resolving driver '%s': %s.\n", drvname, str_error(rc));
 		return rc;
 	}
@@ -330,5 +330,5 @@
 	rc = devman_driver_load(drvh);
 	if (rc != EOK) {
-		printf("Failed loading driver '%s' (%d).\n", drvname, rc);
+		printf("Failed loading driver '%s': %s.\n", drvname, str_error(rc));
 		return rc;
 	}
@@ -344,5 +344,5 @@
 	rc = devman_driver_get_handle(drvname, &drvh);
 	if (rc != EOK) {
-		printf("Failed resolving driver '%s' (%d).\n", drvname, rc);
+		printf("Failed resolving driver '%s': %s.\n", drvname, str_error(rc));
 		return rc;
 	}
@@ -350,5 +350,5 @@
 	rc = devman_driver_unload(drvh);
 	if (rc != EOK) {
-		printf("Failed unloading driver '%s' (%d).\n", drvname, rc);
+		printf("Failed unloading driver '%s': %s.\n", drvname, str_error(rc));
 		return rc;
 	}
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/df/df.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,4 +40,5 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <str_error.h>
 #include <getopt.h>
 #include <errno.h>
@@ -118,6 +119,6 @@
 				return 1;
 		} else {
-			fprintf(stderr, "Cannot get information for '%s' (%d).\n",
-			    mtab_ent->mp, errno);
+			fprintf(stderr, "Cannot get information for '%s' (%s).\n",
+			    mtab_ent->mp, str_error(errno));
 		}
 	}
Index: uspace/app/download/main.c
===================================================================
--- uspace/app/download/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/download/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -224,6 +224,6 @@
 		}
 		
-		int body_size;
-		while ((body_size = recv_buffer(&http->recv_buffer, buf, buf_size)) > 0) {
+		size_t body_size;
+		while ((rc = recv_buffer(&http->recv_buffer, buf, buf_size, &body_size)) == EOK && body_size > 0) {
 			fwrite(buf, 1, body_size, ofile != NULL ? ofile : stdout);
 		}
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/edit/edit.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -955,4 +955,11 @@
 	coord_t coord;
 	int last_row;
+	char *fname;
+	char *p;
+	char *text;
+	size_t n;
+	int pos;
+	size_t nextra;
+	size_t fnw;
 
 	tag_get_pt(&pane.caret_pos, &caret_pt);
@@ -961,12 +968,71 @@
 	sheet_get_num_rows(doc.sh, &last_row);
 
-	const char *fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
+	if (doc.file_name != NULL) {
+		/* Remove directory component */
+		p = str_rchr(doc.file_name, '/');
+		if (p != NULL)
+			fname = str_dup(p + 1);
+		else
+			fname = str_dup(doc.file_name);
+	} else {
+		fname = str_dup("<unnamed>");
+	}
+
+	if (fname == NULL)
+		return;
 
 	console_set_pos(con, 0, scr_rows - 1);
 	console_set_style(con, STYLE_INVERTED);
-	int n = printf(" %d, %d (%d): File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
-	    "Ctrl-E Save As", coord.row, coord.column, last_row, fname);
-	
-	int pos = scr_columns - 1 - n;
+
+	/*
+	 * Make sure the status fits on the screen. This loop should
+	 * be executed at most twice.
+	 */
+	while (true) {
+		int rc = asprintf(&text, " %d, %d (%d): File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
+		    "Ctrl-E Save As", coord.row, coord.column, last_row, fname);
+		if (rc < 0) {
+			n = 0;
+			goto finish;
+		}
+
+		/* If it already fits, we're done */
+		n = str_width(text);
+		if (n <= scr_columns - 2)
+			break;
+
+		/* Compute number of excess characters */
+		nextra = n - (scr_columns - 2);
+		/** With of the file name part */
+		fnw = str_width(fname);
+
+		/*
+		 * If reducing file name to two characters '..' won't help,
+		 * just give up and print a blank status.
+		 */
+		if (nextra > fnw - 2)
+			goto finish;
+
+		/* Compute position where we overwrite with '..\0' */
+		if (fnw >= nextra + 2) {
+			p = fname + str_lsize(fname, fnw - nextra - 2);
+		} else {
+			p = fname;
+		}
+
+		/* Shorten the string */
+		p[0] = p[1] = '.';
+		p[2] = '\0';
+
+		/* Need to format the string once more. */
+		free(text);
+	}
+
+	printf("%s", text);
+	free(text);
+	free(fname);
+finish:
+	/* Fill the rest of the line */
+	pos = scr_columns - 1 - n;
 	printf("%*s", pos, "");
 	console_flush(con);
Index: uspace/app/fdisk/fdisk.c
===================================================================
--- uspace/app/fdisk/fdisk.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/fdisk/fdisk.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -269,4 +269,6 @@
 	return EOK;
 error:
+	assert(rc != EOK);
+	*rsvcid = 0;
 	if (devlist != NULL)
 		fdisk_dev_list_free(devlist);
Index: uspace/app/fontviewer/fontviewer.c
===================================================================
--- uspace/app/fontviewer/fontviewer.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/fontviewer/fontviewer.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,7 @@
 #include <stdlib.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdbool.h>
+#include <str_error.h>
 #include <window.h>
 #include <canvas.h>
@@ -97,5 +98,5 @@
 	int rc = draw();
 	if (rc != EOK) {
-		printf("Failed drawing: %d.\n", rc);
+		printf("Failed drawing: %s.\n", str_error(rc));
 		exit(1);
 	}
@@ -276,5 +277,5 @@
 	int rc = draw();
 	if (rc != EOK) {
-		printf("Failed drawing: %d.\n", rc);
+		printf("Failed drawing: %s.\n", str_error(rc));
 		return 2;
 	}
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/getterm/getterm.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -65,12 +65,16 @@
 	*stream = NULL;
 	
-	int oldfd = vfs_lookup_open(path, WALK_REGULAR, mode);
-	if (oldfd < 0)
+	int oldfd;
+	int rc = vfs_lookup_open(path, WALK_REGULAR, mode, &oldfd);
+	if (rc != EOK)
 		return;
 	
 	if (oldfd != fd) {
-		if (vfs_clone(oldfd, fd, false) != fd)
+		int newfd;
+		if (vfs_clone(oldfd, fd, false, &newfd) != EOK)
 			return;
 		
+		assert(newfd == fd);
+
 		if (vfs_put(oldfd))
 			return;
Index: uspace/app/inet/inet.c
===================================================================
--- uspace/app/inet/inet.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/inet/inet.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -89,5 +89,5 @@
 	rc = loc_service_get_id(link_name, &link_id, 0);
 	if (rc != EOK) {
-		printf(NAME ": Service '%s' not found (%d).\n", link_name, rc);
+		printf(NAME ": Service '%s' not found: %s.\n", link_name, str_error(rc));
 		return ENOENT;
 	}
@@ -135,5 +135,6 @@
 	rc = loc_service_get_id(link_name, &link_id, 0);
 	if (rc != EOK) {
-		printf(NAME ": Service '%s' not found (%d).\n", link_name, rc);
+		printf(NAME ": Service '%s' not found: %s.\n", link_name,
+		    str_error(rc));
 		return ENOENT;
 	}
@@ -141,5 +142,6 @@
 	rc = inetcfg_addr_get_id(aobj_name, link_id, &addr_id);
 	if (rc != EOK) {
-		printf(NAME ": Address '%s' not found (%d).\n", aobj_name, rc);
+		printf(NAME ": Address '%s' not found: %s.\n", aobj_name,
+		    str_error(rc));
 		return ENOENT;
 	}
@@ -147,6 +149,6 @@
 	rc = inetcfg_addr_delete(addr_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed deleting address '%s' (%d)\n", aobj_name,
-		    rc);
+		printf(NAME ": Failed deleting address '%s': %s\n", aobj_name,
+		    str_error(rc));
 		return EIO;
 	}
@@ -197,6 +199,6 @@
 	rc = inetcfg_sroute_create(route_name, &dest, &router, &sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed creating static route '%s' (%d)\n",
-		    route_name, rc);
+		printf(NAME ": Failed creating static route '%s': %s\n",
+		    route_name, str_error(rc));
 		return EIO;
 	}
@@ -227,6 +229,6 @@
 	rc = inetcfg_sroute_get_id(route_name, &sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Static route '%s' not found (%d).\n",
-		    route_name, rc);
+		printf(NAME ": Static route '%s' not found: %s.\n",
+		    route_name, str_error(rc));
 		return ENOENT;
 	}
@@ -234,6 +236,6 @@
 	rc = inetcfg_sroute_delete(sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed deleting static route '%s' (%d)\n",
-		    route_name, rc);
+		printf(NAME ": Failed deleting static route '%s': %s\n",
+		    route_name, str_error(rc));
 		return EIO;
 	}
@@ -486,6 +488,6 @@
 	rc = inetcfg_init();
 	if (rc != EOK) {
-		printf(NAME ": Failed connecting to internet service (%d).\n",
-		    rc);
+		printf(NAME ": Failed connecting to internet service: %s.\n",
+		    str_error(rc));
 		return 1;
 	}
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/init/init.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,5 +41,5 @@
 #include <errno.h>
 #include <task.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <macros.h>
 #include <str.h>
Index: uspace/app/killall/killall.c
===================================================================
--- uspace/app/killall/killall.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/killall/killall.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,5 +39,5 @@
 #include <stats.h>
 #include <str_error.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #define NAME  "killall"
